function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useEffect, useState } from 'react';
import useNode from './useNode';
import { Form, Input } from 'antd';
import ConfigLoading from './configLoading';
import Expression from '../../../../components/expression';
import { getFieldNameError, getFieldInputErrorInfo } from './utils';
import '../styles/computeColumn.less';
import _ from 'lodash';
// 计算列动作
var ComputeColumnConfig = function ComputeColumnConfig(_ref) {
  var node = _ref.node,
    nodeList = _ref.nodeList;
  var classPrefix = 'computeColumn-config';
  var nodeData = node.getData();
  var _useState = useState(nodeData.label),
    _useState2 = _slicedToArray(_useState, 2),
    actName = _useState2[0],
    setActName = _useState2[1];
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var _useNode = useNode(node),
    columnList = _useNode.columnList,
    loading = _useNode.loading;
  var _useState3 = useState(nodeData),
    _useState4 = _slicedToArray(_useState3, 2),
    formValue = _useState4[0],
    setFormValue = _useState4[1];
  var _useState5 = useState(nodeData.expression),
    _useState6 = _slicedToArray(_useState5, 2),
    expression = _useState6[0],
    setExpression = _useState6[1];
  var _useState7 = useState(''),
    _useState8 = _slicedToArray(_useState7, 2),
    errMsg = _useState8[0],
    setErrMsg = _useState8[1];
  useEffect(function () {
    node.updateData(_objectSpread(_objectSpread({}, formValue), {}, {
      status: actName && formValue.fieldName && expression && errMsg === '' ? 'success' : 'failed',
      expression: expression,
      fieldType: 'bigint',
      label: actName
    }));
  }, [formValue, expression, actName, errMsg]);
  var onValuesChange = function onValuesChange(__, allData) {
    setFormValue(_objectSpread({}, allData));
  };
  if (loading) {
    return /*#__PURE__*/React.createElement(ConfigLoading, null);
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/React.createElement(Form, {
    form: form,
    onValuesChange: onValuesChange,
    initialValues: _objectSpread({}, formValue)
  }, /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u52A8\u4F5C\u540D\u79F0",
    colon: false,
    className: "action-name-box ".concat(actName === '' && 'error')
  }, /*#__PURE__*/React.createElement(Input, {
    value: actName,
    maxLength: 50,
    showCount: true,
    onChange: function onChange(e) {
      return setActName(_.trim(e.currentTarget.value));
    }
  }), actName === '' && /*#__PURE__*/React.createElement("div", {
    className: "action-name-box-error"
  }, "\u8BF7\u8F93\u5165\u52A8\u4F5C\u540D\u79F0")), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u65B0\u5EFA\u5B57\u6BB5\u540D\u79F0",
    name: "fieldName",
    colon: false,
    rules: [{
      validator: function validator(_, value) {
        if (value === '') {
          return Promise.reject(new Error('请输入字段名称'));
        }
        var msg = getFieldInputErrorInfo(value);
        if (msg) {
          return Promise.reject(new Error(msg));
        }
        if (getFieldNameError(nodeList, columnList, value, nodeData)) {
          return Promise.reject(new Error('字段名称已存在'));
        }
      }
    }]
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: "\u8BF7\u8F93\u5165\u65B0\u5EFA\u5B57\u6BB5\u540D\u79F0",
    maxLength: 200,
    showCount: true
  })), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u6CE8\u91CA",
    name: "alias",
    colon: false
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: "\u8BF7\u8F93\u5165\u6CE8\u91CA",
    maxLength: 200,
    showCount: true
  })), /*#__PURE__*/React.createElement(Expression, {
    columnList: columnList.filter(function (item) {
      return ['number', 'string'].includes(item.webType);
    }),
    expression: expression,
    setExpression: setExpression,
    errMsg: errMsg,
    setErrMsg: setErrMsg
  })));
};
export default ComputeColumnConfig;